//
//  AppController.m
//  TokenTest
//
//  Created by René Rebe on 8/21/06.
//  Copyright 2006 ExactCODE. All rights reserved.
//

#import "AppController.h"

@implementation AppController

- (id)init
{
	NSLog (@"here");
    return self;
}

// ---------------------------------------------------------------------------
//	- applicationDidFinishLaunching
// ---------------------------------------------------------------------------
- (void)applicationDidFinishLaunching: (NSNotification *)notification
{
/*
	NSRect a = [tokens frame];
	a.size.height *= 2;
	[tokens setFrameSize: a.size];
	NSLog (@"here %f %f", a.size.width, a.size.height);
*/
	NSLog (@"finishedLaunching");

	NSString* str = [NSString stringWithCString: ""];
	NSCharacterSet* set = [NSCharacterSet characterSetWithCharactersInString: str];
	[tokens setTokenizingCharacterSet: set];
	[tokens setTokenStyle: NSPlainTextTokenStyle];
	
	NSLog (@"Current: %@", [tokens objectValue]);
}

- (NSArray *)tokenField:(NSTokenField *)tokenField shouldAddObjects:(NSArray *)_tokens atIndex:(unsigned)index
{
	NSLog (@"shouldAdd");
//	NSArray* array = [NSArray new];
	
	NSEnumerator* enumerator = [_tokens objectEnumerator];
	id anObject;
	
	int i = 0;
	while (anObject = [enumerator nextObject]) {
		/* code to act on each element as it is returned */
		NSLog (@"%d: %@", i++, [anObject description]);
	}

	return _tokens; //array;
}


- (NSString *)tokenField:(NSTokenField *)tokenField displayStringForRepresentedObject:(id)representedObject
{
	NSLog (@"stringForRepresented");
	NSString* string;
	if ([representedObject isKindOfClass: [MyToken class]]) {
		MyToken* token = representedObject;
		string = [token text];
	}
	else
		string = representedObject;
	return string;
}

- (NSTokenStyle)tokenField:(NSTokenField *)tokenField styleForRepresentedObject:(id)representedObject
{
	NSLog (@"styleForRepresented");
	if ([representedObject isKindOfClass: [MyToken class]])
		return NSRoundedTokenStyle;
	return NSPlainTextTokenStyle;
}

- (BOOL)tokenField:(NSTokenField *)tokenField hasMenuForRepresentedObject:(id)representedObject
{
	NSLog (@"hasMenuForRepresented");
	if ([representedObject isKindOfClass: [MyToken class]])
		return YES;
	return NO;
}

static MyToken* menuToken;

- (NSMenu *)tokenField:(NSTokenField *)tokenField menuForRepresentedObject:(id)representedObject
{
	NSLog (@"menueForRepresented");
	if ([representedObject isKindOfClass: [MyToken class]]) {
		menuToken = representedObject;
		return tokenMenu;
	}
	return nil;
}

- (IBAction)testMe: (id)sender;
{
	NSMutableArray* array = [tokens objectValue];
	NSLog (@"Current: %@", array);
	
	MyToken* token = [MyToken new];
	[token setText: @"Vanilla"];
	
/*
	NSRange* selectedRange = [tokens selectedRange];
	
	int start = selectedRange->location;
	int length = selectedRange->length;
	
	NSLog (@"selected: %d-%d", start, length);
*/
	
	[array addObject: token];
	
	[tokens setObjectValue: array];
}

- (IBAction)contextClick: (id)sender;
{
	NSLog (@"contextClick: %@", sender);
	NSMenuItem* item = sender;
	
	NSLog (@"title: %@", [item title]);
	[menuToken setText: [item title]];

	[tokens setObjectValue: [tokens objectValue]];
}

@end
