//
//  MyToken.m
//  TokenTest
//
//  Created by René Rebe on 8/21/06.
//  Copyright 2006 ExactCODE. All rights reserved.
//

#import "MyToken.h"

@implementation MyToken

- (void)encodeWithCoder:(NSCoder *)encoder
{
	NSLog (@"keyed encoding: %d", (int)[encoder allowsKeyedCoding]);
	//[encoder encodeFloat:0.2 forKey:@"Text"];
	[encoder encodeObject:name];
}

- (id)initWithCoder:(NSCoder *)decoder
{
	//self = [MYToken alloc];
	name = [[decoder decodeObject] retain];
	return self;
}

- (void)setText:(NSString *)text
{
	name = [[NSString alloc] initWithString: text];
}

- (NSString *)text
{
	return name;
}
@end
